var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});

// src/util/props.ts
function getRootName(object) {
  if (object.type === "MemberExpression") {
    return getRootName(object.object);
  }
  if (object.type === "CallExpression") {
    return getRootName(object.callee);
  }
  if (object.type === "Identifier") {
    return object.name;
  }
  throw new Error("Root object is not an identifier");
}

// src/rules/safe-function-exports/errors.ts
var INVALID_FUNCTION_EXPORT = "Cannot have a firebase function that is not exported";

// src/rules/safe-function-exports/index.ts
var safeFunctionExports = {
  create: (context) => {
    const { importStarName = "functions" } = context.options[0] || {};
    const hasFirebaseImports = context.getSourceCode().ast.body.some((node) => {
      if (node.type === "ImportDeclaration") {
        const namespaces = node.specifiers.filter((specifier) => specifier.type === "ImportNamespaceSpecifier");
        if (namespaces.length === 0) {
          return false;
        }
        return node.source.type === "Literal" && node.source.value === "firebase-functions" && namespaces.some((namespace) => namespace.local.name === importStarName);
      }
      return false;
    });
    if (!hasFirebaseImports) {
      return {};
    }
    return {
      VariableDeclaration(node) {
        const isFirebaseFunction = node.kind === "const" && node.declarations.every((declaration) => {
          if (declaration.init && declaration.init.type === "CallExpression" && declaration.init.callee.type === "MemberExpression" && declaration.init.callee.object) {
            const rootName = getRootName(declaration.init.callee.object);
            return rootName === importStarName;
          }
          return false;
        });
        if (!isFirebaseFunction) {
          return;
        }
        const isExported = node.parent.type === "ExportNamedDeclaration";
        if (!isExported) {
          context.report({
            node,
            messageId: "INVALID_FUNCTION_EXPORT",
            fix(fixer) {
              return [fixer.insertTextBefore(node, "export ")];
            }
          });
        }
      }
    };
  },
  meta: {
    fixable: "code",
    messages: { INVALID_FUNCTION_EXPORT }
  }
};

// src/index.ts
var src_default = {
  rules: {
    "safe-function-exports": safeFunctionExports
  }
};
module.exports = __toCommonJS(src_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
